package cn.wustlinghang.wusthelper.rpc.response;

public record RpcResponse<T>(int code, String msg, T data) {
    public static <T> RpcResponse<T> success(T data) {
        return new RpcResponse<>(ResponseCode.SUCCESS.getCode(), "ok", data);
    }

    public static <T> RpcResponse<T> success() {
        return success(null);
    }

    public static <T> RpcResponse<T> error(int code, String message) {
        return new RpcResponse<>(code, message, null);
    }

    public static <T> RpcResponse<T> error(ResponseCode code) {
        return error(code.getCode(), code.getMessage());
    }
}