package cn.wustlinghang.wusthelper.internal.undergrad.api.json;

import cn.wustlinghang.mywust.data.global.Score;
import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.wusthelper.internal.undergrad.services.ParseService;
import cn.wustlinghang.wusthelper.internal.undergrad.services.RequestAgentService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;
import java.util.List;

@Path("/score")
@ApplicationScoped
public class ScoreApi {
    private final RequestAgentService agentService;
    private final ParseService parseService;

    public ScoreApi(RequestAgentService agentService,
                    ParseService parseService) {
        this.agentService = agentService;
        this.parseService = parseService;
    }

    @GET
    @Path("/")
    public List<Score> get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return this.parse(this.agent(cookie));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return agentService.getScore(cookie);
    }

    @POST
    @Path("/parse")
    public List<Score> parse(String html) throws RpcException {
        return parseService.parseScore(html);
    }
}
