package cn.wustlinghang.wusthelper.internal.undergrad.api.json;

import cn.wustlinghang.mywust.exception.ApiException;
import cn.wustlinghang.mywust.exception.ParseException;
import cn.wustlinghang.wusthelper.internal.undergrad.services.ParseService;
import cn.wustlinghang.wusthelper.internal.undergrad.services.RequestAgentService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.io.IOException;

@Path("/credit_status")
@ApplicationScoped
public class CreditStatusApi {
    private final RequestAgentService agentService;
    private final ParseService parseService;

    public CreditStatusApi(RequestAgentService agentService,
                           ParseService parseService) {
        this.agentService = agentService;
        this.parseService = parseService;
    }
    
    @GET
    @Path("/")
    public String get(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        String html = this.agent(cookie);
        return this.parse(html);
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie)
            throws RpcException {
        return agentService.getCreditStatus(cookie);
    }

    @POST
    @Path("/parse")
    public String parse(String html) throws RpcException {
        return parseService.parseCreditStatus(html);
    }
}
