package cn.wustlinghang.wusthelper.internal.undergrad.api.json;

import cn.wustlinghang.mywust.data.undergrad.ExamDelayApplication;
import cn.wustlinghang.wusthelper.internal.undergrad.services.ParseService;
import cn.wustlinghang.wusthelper.internal.undergrad.services.RequestAgentService;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.validation.constraints.NotNull;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.POST;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.QueryParam;

import java.util.List;

@Path("/exam_delay_application")
@ApplicationScoped
public class ExamDelayApplicationApi {
    private final RequestAgentService agentService;
    private final ParseService parseService;

    public ExamDelayApplicationApi(RequestAgentService agentService,
                                   ParseService parseService) {
        this.agentService = agentService;
        this.parseService = parseService;
    }

    @GET
    @Path("/")
    public List<ExamDelayApplication> get(
            @QueryParam("cookie") @NotNull String cookie,
            @QueryParam("term") @NotNull String term,
            @QueryParam("activity_id") @NotNull String activityId)
            throws RpcException {
        return this.parse(this.agent(cookie, term, activityId));
    }

    @GET
    @Path("/agent")
    public String agent(@QueryParam("cookie") @NotNull String cookie,
                        @QueryParam("term") @NotNull String term,
                        @QueryParam("activity_id") @NotNull String activityId)
            throws RpcException {
        return agentService.getExamDelayApplications(cookie, term, activityId);
    }

    @POST
    @Path("/parse")
    public List<ExamDelayApplication> parse(String html) throws RpcException {
        return parseService.parseExamDelayApplications(html);
    }
}
