package cn.wustlinghang.wusthelper.internal.undergrad.api.json.handler;

import cn.wustlinghang.wusthelper.internal.undergrad.exception.UndergradRpcException;
import cn.wustlinghang.wusthelper.rpc.exception.RpcException;
import jakarta.ws.rs.WebApplicationException;
import jakarta.ws.rs.core.Response;
import jakarta.ws.rs.ext.ExceptionMapper;
import jakarta.ws.rs.ext.Provider;

@Provider
public class WebApplicationExceptionHandler extends BaseExceptionHandler implements ExceptionMapper<WebApplicationException> {
    @Override
    public Response toResponse(WebApplicationException e) {
        return super.toResponse(
                e.getResponse().getStatus(),
                RpcException.toIntCode(
                        UndergradRpcException.UNDERGRAD_MODULE,
                        UndergradRpcException.SubModuleCode.COMMON.ordinal(),
                        UndergradRpcException.TypeCode.OTHER_EXCEPTION.ordinal() * 100
                                + UndergradRpcException.ErrorCode.REQUEST_INVALID.ordinal()
                ),
                e.getMessage(),
                "WebApplicationExceptionHandler"
        );
    }
}
